--[[
dialog-test.lua

testing the dialog library

functions:
dialog.messagebox(text, caption, button_flag, icon_flag):
    displays a messagebox.
    text: the text to be displayed
    caption: the desired caption. defaults to "Lua script".
    button_flag: one of dialog.MB_ABORTRETRYIGNORE, dialog.MB_OK, dialog.MB_OKCANCEL,
        dialog.MB_RETRYCANCEL, dialog.MB_YESNO, dialog.MB_YESNOCANCEL.
        defaults to dialog.MB_OK.
    icon_flag: one of
        dialog.MB_ICONASTERISK, dialog.MB_ICONEXCLAMATION,
        dialog.MB_ICONINFORMATION,
        dialog.MB_ICONQUESTION,
        dialog.MB_ICONERROR, dialog.MB_ICONHAND, dialog.MB_ICONSTOP.
        defaults to none.
    returns one of dialog.IDABORT, dialog.IDCANCEL, dialog.IDIGNORE, dialog.IDNO, dialog.IDOK, 
        dialog.IDRETRY, dialog.IDYES.
]]

dialog.messagebox("The first test: only text.\n"..
    "Let's try a very, very long line. Yeah, it keeps on going, further and further. Even beyond this. Mmmh, this is really getting long now.")

dialog.messagebox("The second test: text and caption.", "Messagebox test")

local rv = dialog.messagebox("The third test: text, caption, and a choice...", "Messagebox test", dialog.MB_YESNO)
local chosen

if rv == dialog.IDYES then
    chosen = "yes"
elseif rv == dialog.IDNO then
    chosen = "no"
else
    error("unexpected return value from dialog.messagebox")
end

dialog.messagebox(
    "You have chosen: "..chosen..".\n"..
    "The fourth test: text, caption, and an icon.\nThis ends the messagebox tests.",
    "Messagebox test", nil, dialog.MB_ICONINFORMATION)
