--[[
fb2k.playlist library

Unless noted otherwise, all indices are 1-based.

fb2k.playlist.get_count() -- returns number of playlist items
fb2k.playlist.get_item(index) -- returns metadb_handle, or nil if index is invalid
fb2k.playlist.get_data() -- returns list of metadb_handle objects
fb2k.playlist.get_focus() -- returns number or nil
fb2k.playlist.get_focus_item() -- returns metadb_handle or nil
fb2k.playlist.set_focus(index) -- set focus to item at index n, selection is not affected
fb2k.playlist.set_focus_sel(n) -- set focus to item at index n, select item at index n, deselect all other items
fb2k.playlist.get_now_playing() -- returns index of currently playing item, nil if none or not in playlist
fb2k.playlist.ensure_visible(n) -- ensure that item at index n is visible

fb2k.playlist.get_sel(n) -- returns whether item at index n is selected
fb2k.playlist.set_sel(n, state) -- sets selection state of item at index n; state is boolean
fb2k.playlist.set_sel_mask(sel, mask = bit_array_true()) -- sel and mask are bit_array objects;
	selection state of playlist item at index n is set to sel[n], if mask[n] is true
fb2k.playlist.set_sel_one(n) -- selects item at index n, deselects all other items
fb2k.playlist.get_sel_mask() -- returns selection as bit_array object and number of items in playlist
fb2k.playlist.get_sel_items() -- returns list of metadb_handle objects
fb2k.playlist.get_sel_count() -- returns number of selected items

fb2k.playlist.format_title(index, spec) -- returns string
fb2k.playlist.get_format_spec() -- returns format string

fb2k.playlist.add_items(items, replace = false, insert_index = -1, select = false, filter = true) -- items is a list of metad_handle objects
fb2k.playlist.add_item(item, replace = false, insert_idx = nil, select = false, filter = true) -- item is a metadb_handle object
fb2k.playlist.add_locations(urls, replace = false, insert_idx = nil, select = false, filter = true) -- urls is a list of strings
fb2k.playlist.add_location(url, replace = false, insert_idx = nil, select = false, filter = true) -- url is a string
fb2k.playlist.remove_mask(mask) -- mask is a bit_array object;
	playlist item at index n is removed, if mask[n] is true
fb2k.playlist.remove_sel() -- selected items are removed
fb2k.playlist.remove_item(n) -- item at index n is removed
fb2k.playlist.remove_all()
fb2k.playlist.replace_item(n, item) -- replaces item at index n with item (given as metadb_handle)

fb2k.playlist.get_playback_cursor()
fb2k.playlist.set_playback_cursor()
fb2k.playlist.playback_advance(cmd = "default") -- returns metadb_handle object of track that would be played according to cmd
	possible values for cmd: "default", "play", "next", "prev", "rand", "abort"

fb2k.playlist.apply_order(order) -- order is a list of indices describing a permutation
	if order[n] == m, then the item at index m is moved to index n
fb2k.playlist.sort_by_format(spec, sel_only) -- sorts playlist using format string spec; if sel_only is true, only the selection is sorted
fb2k.playlist.move_items(delta) -- moves selected items by delta

fb2k.playlist.undo_restore()
fb2k.playlist.undo_reset()

fb2k.playlist.play_item(n) -- play item at index n
]]
