--[[
metadb-test.lua
]]

assert(loadmodule("fb2k.metab"))

LUA_PATH = "d:\\media\\script\\fb2k\\?.lua"

require "common"

function print(...)
	fb2k.console.info(table.concat(arg))
end

function main()
    fb2k.console.popup()
    print("now running: metadb-test.lua")
    
    print("testing metadb.get_all_entries()...")
    t = fb2k.metadb.get_all_entries()
    if t then
        local count = table.getn(t)
        print("number of items in database: " .. count)
        
        if count > 0 then
            print("testing metadb_handle:format_title()...")
            local handle = t[1]
            text = handle:format_title("%artist% '['%album%']' %title% '('%_filename_ext%')'") 
            print(text or "failed")
            print("testing metadb_handle:query()...")
            local info = handle:query()
            print("get_info('bitrate'): ", quote(info:info_get('bitrate')))
            print("get_all_info(): ", quote(info:info_get_all()))
            print("get_meta('artist'): ", quote(info:meta_get('artist')))
            print("get_all_meta(): ", quote(info:meta_get_all()))
        end
    end

end

main()
