--[[
os-test.lua

testing the os library

os.clock()
os.date([format, [time] ])
os.difftime(t2, t1)
os.execute(command)
os.exit()
os.getenv(varname)
os.remove(filename)
os.rename(old, new)
os.setlocale(locale, [category])
os.time([table])
]]

LUA_PATH = "?.lua"

require "common"

function wait_user(msg)
    dialog.messagebox(msg,"OS test",dialog.MB_OK,dialog.MB_ICONINFORMATION)
end

local function yes_or_no(msg)
	return dialog.yes_or_no(msg,"OS test")
end

-- the main program
function main()
	console.popup()
    console.info("now running: os-test.lua")
    
	console.info("os.clock() => "..quote(os.clock()))
	
	console.info("os.date() => "..quote(os.date()))
	console.info("os.date('!%c') => "..quote(os.date('!%c')))
	console.info("os.date('*t') => "..quote(os.date('*t')))
	console.info("os.date('!*t') => "..quote(os.date('!*t')))
	
	console.info("os.getenv('PATH') => "..quote(utf8.from_ansi(os.getenv('PATH'))))
	
	local rv = yes_or_no("Do you want to test os.exit()?\nThis will exit the program.")
	if rv == "yes" then
		console.info("os.exit()")
		os.exit()
	end
end

main()
