--[[
utf8 library

Functions corresponding to those in the standard string library, but for working with UTF-8.
Unless noted otherwise, all indices are given in bytes.

utf8.decode() -- decodes UTF-8 characters
	utf8.decode(string, n) returns the code of the character starting at byte n. Returns nil for n < 1 or n > utf8.len(s).
	utf8.decode(string, n, m) returns a table containing the codes of the characters between byte n and byte m.
utf8.encode() -- encodes UTF-8 characters
	utf8.encode(c1, c2, ..., cN) returns the string consisting of the characters with codes c1 to cN
	utf8.encode({c1, c2, ..., cN}) returns the string consisting of the characters with codes c1 to cN

utf8.len(string) -- returns the length of string in characters

utf8.find(string, pattern, init = 1, plain = false) -- corresponds to string.find; init is given in bytes;
	if an occurence of pattern is found in string, it returns the byte indices where this occurence starts and ends.
utf8.gfind(string, pattern)
utf8.gsub(string, pattern, repl [, n])

utf8.sub(string, start [,end]) -- like string.sub, but start and end are character indices.

utf8.lower(string)
utf8.upper(string)

utf8.from_ani(s) -- returns UTF-8 version of the ANSI string s
utf8.to_anso(s) -- returns ANSI version of the UTF-8 string s
utf8.validate(s) -- returns true, if s is a valid UTF-8 string, false otherwise

]]
