--[[
util.bit_array library

Unless noted otherwise, all indices are 1-based.

bit_array:get(n) -- returns boolean
bit_array[n] -- returns boolean
bit_array:find(val, start, count) -- count may be negative for searching backwards
bit_array:calc_count(val, start, count) -- count must be non-negative

bit_array_var:set(n, val)
bit_array_var[n] = val

util.bit_array_false() -- returns bit_array x with x[n] == false for all indices n
util.bit_array_true() -- returns bit_array x with x[n] == true for all indices n
util.bit_array_val(val) -- returns bit_array x with x[n] == val for all indices n
util.bit_array_one(n) -- returns bit_array x with x[n] == true and x[m] == false for m ~= n
util.bit_array_range(start, count, val) -- returns bit_array x with x[n] == val for n >= start and n < start + count, and x[n] == not val otherwise
util.bit_array_not(a) -- returns bit_array x with x[n] == not a[n]
util.bit_array_shift(a, delta) -- returns bit_array with x[n] == a[n-delta]
util.bit_array_and(a, b) -- returns bit_array x with x[n] == (a[n] and b[n])
util.bit_array_or(a, b) -- returns bit_array x with x[n] == (a[n] or b[n])
util.bit_array_xor(a, b) -- returns bit_array x with x[n] == (a[n] ~= b[n])
util.bit_array_table(count) -- returns bit_array_var with count modifiable entries
util.bit_array_table(t, count = table.getn(t)) -- returns bit_array_var x with count modifiable entries; x[n] is initialized to t[n] for n >= 1 and n <= count
]]
