--[[
growsel.lua
Use with foobar2000+foo_lua
Type: main menu command

Select all items in the playlist that match a given criterion.
(Default: All items that have the same artist as the active item.)
]]

-- option
casesensitive = true

function same_format(ref,spec,n)
    local s = playlist.format_title(n,spec)
    if casesensitive then
        return s == ref
    else
        return string.lower(s) == ref
    end
end

function main()
    -- get number of items in playlist
    local count = playlist.get_count()
    
    -- get active item
    local focus = playlist.get_focus()
    
    -- playlist.get_focus() returns nil, when no item is active
    if focus then
        -- the formatting string to use
        local spec = "%artist%"
        
        -- compute the reference string
        local ref = playlist.format_title(focus,spec)
        if not casesensitive then
            ref = string.lower(ref)
        end
        
        -- we're lazy typers, so...
        local function pred(n) return same_format(ref,spec,n) end
        
        --iterate over all items in the playlist
        local n = 1
        while n <= count do
            playlist.set_sel(n,pred(n))
            n = n+1
        end
    end
end

main()
