--[[*
Draws together songs from same album in playlist.

@author foosion
@requires foo_lua 0.2
@contextcommand Sort/Compact album
]]

-- check correct call mode
assert(_COMMANDMODE == 'context menu',
	'this script needs to be run from foo_lua as a context menu command')
if not arg[2] then return end -- playlist only

-- check availability of libraries
assert(fb2k and fb2k.playlist or loadmodule("fb2k.playlist"))
assert(util and util.bit_array or loadmodule("util.bit_array"))

-- shortcut	
local pl = fb2k.playlist

local focus = pl.get_focus()
if not focus then return end

local spec = "$if2($lower(%album%),%_filename%)"
local refval = pl.format_title(focus, spec)

local count = pl.get_count()
local mask = util.bit_array_table(count)
for idx = 1, count do
	local val = pl.format_title(idx, spec)
	mask[idx] = (val == refval)
end
pl.set_sel_mask(mask)
local idx = mask:find(true, 1, count)
while mask[idx] do
	idx = idx + 1
end
if mask:find(true, idx + 1, count - idx) then
	-- selection is not contiguous
	local order = {n=count}
	local lo = 1
	local hi = focus - mask:calc_count(true, lo, focus - lo)
	print(lo, hi)
	for idx = lo, focus - 1 do
		if mask[idx] then
			order[hi] = idx
			hi = hi + 1
		else
			order[lo] = idx
			lo = lo + 1
		end
	end
	order[focus] = focus
	lo = focus + 1
	hi = lo + mask:calc_count(true, focus + 1, count - focus)
	print(lo, hi)
	for idx = lo, count do
		if mask[idx] then
			order[lo] = idx
			lo = lo + 1
		else
			order[hi] = idx
			hi = hi + 1
		end
	end
	print(count, focus)
	for idx = 1, count do
		--print(idx.." -> "..order[idx])
	end
	pl.apply_order(order)
	pl.sort_by_format("$num(%disc%,2)$num(%tracknumber%,2)", true)
end
